TYPO3 Core - Epic #84729
Epic # 84726 (Closed): Initiative: URL Routing Integration / Site Handling
Epic # 84728 (Closed): Introduce speaking URLs for pages

Implement "slug™ handling for pages and other records

2018-04-15 10:53 - Benni Mack

Status: Closed

Priority: Should have

Assignee: Benni Mack

Category: Link Handling, Site Handling & Routing
Target version: 9.4

Sprint Focus:

Start date:
Due date:

% Done:

Estimated time:

2018-08-23

100%
0.00 hour

Description
1. Create a new pages DB field "slug" ("URL path")

2. Create a new TCA type "type=slug"

- FormEngine: renders an input field and validates against URI schemes (JS validation), prepends the current / configured site to get

the full URL

- Also Consider (Copy 1) in pages etc. so they geta"-1"and nota '

- Validate for "Uniqueness" on save (or before?)
- TCA type "slug":

type = 'slug'

config [

'valueFields' => ['a-field-from-the-same-table’, 'another-field"], - special key "site-rootline"

'fieldSeparator' => /' => (so you could do /year/month/title/uid’)
'custom' => Userfunc?

]

Open topics:
- discuss if slugs always need a prepending or a appending slash?
- Should we still allow ?id=123 ?

"-copy1"

3. Create a CLI command to create slugs for pages (or all TCA tables) - allow to migrate from realurl?

4. Create an upgrade wizard that does the same
5. Ensure that all pages within a site have a slug - possible?
6. Handle things like "moving a page to a different site"

Subtasks:

Task # 85937: Generate default slug for entities not being submitted via FormEngine

Task # 85938: Handle renaming of "base" property of a site

Bug # 85957: Pages on root level cannot be created now

Bug # 86073: Create url segment if localizing page

Bug # 86074: Properly create slug if adding new pages via FormEngine
Task # 86077: Add recreate button to slug field

Closed
Rejected
Closed
Rejected
Closed
Closed

Associated revisions

Revision 7df267¢8 - 2018-08-23 12:23 - Benni Mack
[FEATURE] Add a new TCA type "slug"

A new TCA type "slug" is added, which allows to generate a part of a URL
which can later be used for adding URL segments to any kind of record.

The new slug TCA type will be added to the pages database table separately

to fill a page with the rootline "Home => Products => My Product" with
"/products/my-product/details/" into the slug field when creating
a subpage "Details" under "My Product".

Once the slug field is added when persisting the record, changing a title

(like the page title) will not modify the slug anymore, but instead this
has to be modified separately.
Next steps:

- Add the TCA type "slug" to pages table

- Introduce an upgrade wizard for that pages table

- Improve FormEngine via AJAX validation of "uniquelnSite" for slugs
- Implement slug resolving for pages.

Resolves: #84729

Releases: master

Change-1d: 1079267f42308f40da71ab4765ba7e0251e79f736
Reviewed-on: https://review.typo3.org/56889

Tested-by: TYPO3com <no-reply@typo3.com>
Reviewed-by: Oliver Hader <oliver.hader@typo3.org>
Tested-by: Oliver Hader <oliver.hader@typo3.org>
Reviewed-by: Christian Kuhn <lolli@schwarzbu.ch>
Tested-by: Christian Kuhn <lolli@schwarzbu.ch>

History

#1 - 2018-05-13 23:03 - Gerrit Code Review

- Status changed from New to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#2 - 2018-05-17 10:41 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#3 - 2018-05-17 10:51 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#4 - 2018-05-22 07:58 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https:/review.typo3.0rg/56889

#5 - 2018-05-22 21:04 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#6 - 2018-05-25 15:34 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#7 - 2018-05-29 23:01 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https:/review.typo3.0rg/56889

#8 - 2018-06-06 13:19 - Benni Mack

- Target version changed from 9.3 to 9.4

#9 - 2018-08-11 21:55 - Gerrit Code Review

Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#10 - 2018-08-22 11:14 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/56889

#11 - 2018-08-22 11:23 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/56889

#12 - 2018-08-22 12:48 - Gerrit Code Review

2021-10-25 2/4


https://review.typo3.org/56889
mailto:no-reply@typo3.com
mailto:oliver.hader@typo3.org
mailto:oliver.hader@typo3.org
mailto:lolli@schwarzbu.ch
mailto:lolli@schwarzbu.ch
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889
https://review.typo3.org/56889

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#13 - 2018-08-22 15:29 - Gerrit Code Review

Patch set 13 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#14 - 2018-08-22 15:42 - Gerrit Code Review

Patch set 14 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/56889

#15 - 2018-08-22 18:20 - Gerrit Code Review

Patch set 15 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#16 - 2018-08-22 19:55 - Gerrit Code Review

Patch set 16 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#17 - 2018-08-22 20:42 - Gerrit Code Review

Patch set 17 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/56889

#18 - 2018-08-22 21:18 - Gerrit Code Review

Patch set 18 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#19 - 2018-08-22 22:39 - Gerrit Code Review

Patch set 19 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#20 - 2018-08-22 22:56 - Gerrit Code Review

Patch set 20 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/56889

#21 - 2018-08-22 23:10 - Gerrit Code Review

Patch set 21 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#22 - 2018-08-23 08:34 - Gerrit Code Review

Patch set 22 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#23 - 2018-08-23 09:29 - Gerrit Code Review

Patch set 23 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/56889

#24 - 2018-08-23 09:50 - Gerrit Code Review

Patch set 24 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#25 - 2018-08-23 10:22 - Gerrit Code Review

Patch set 25 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/56889

#26 - 2018-08-23 11:08 - Gerrit Code Review

Patch set 26 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/56889

#27 - 2018-08-23 12:01 - Gerrit Code Review
Patch set 27 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/56889

#28 - 2018-08-23 12:30 - Benni Mack
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset 7df267c885f4e7f065c36423faebf761d4194cff.

#29 - 2018-09-01 20:42 - Christian Kuhn
- Related to Bug #86073: Create url segment if localizing page added

#30 - 2018-09-01 20:44 - Christian Kuhn
- Related to deleted (Bug #86073: Create url segment if localizing page)

#31 - 2018-09-20 23:04 - David Bruchmann

Benni Mack wrote:

Applied in changeset 7df267c885f4e7f065c36423faebf761d4194cff.

In line 44 of SlugHelperTest is written "'strig tags' => [", is "strig" correct?

I'd suppose it shall be "string" ...

#32 - 2018-10-02 10:47 - Benni Mack

- Status changed from Resolved to Closed
